diff --git a/app/test/test_reassembly_perf.c b/app/test/test_reassembly_perf.c
index 3912179022..805ae2fe9d 100644
--- a/app/test/test_reassembly_perf.c
+++ b/app/test/test_reassembly_perf.c
@@ -20,7 +20,7 @@
 #define MAX_FLOWS	    (1024 * 32)
 #define MAX_BKTS	    MAX_FLOWS
 #define MAX_ENTRIES_PER_BKT 16
-#define MAX_FRAGMENTS	    RTE_LIBRTE_IP_FRAG_MAX_FRAG
+#define MAX_FRAGMENTS	    RTE_IP_FRAG_MAX_FRAG
 #define MIN_FRAGMENTS	    2
 #define MAX_PKTS	    (MAX_FLOWS * MAX_FRAGMENTS)
 
diff --git a/config/rte_config.h b/config/rte_config.h
index a3f92354f8..1f4567b0d2 100644
--- a/config/rte_config.h
+++ b/config/rte_config.h
@@ -85,7 +85,7 @@
 #define RTE_RAWDEV_MAX_DEVS 64
 
 /* ip_fragmentation defines 8< */
-#define RTE_LIBRTE_IP_FRAG_MAX_FRAG 8
+#define RTE_IP_FRAG_MAX_FRAG 8
 /* >8 End of ip_fragmentation defines */
 
 // RTE_LIBRTE_IP_FRAG_TBL_STAT is not set
diff --git a/doc/guides/prog_guide/ip_fragment_reassembly_lib.rst b/doc/guides/prog_guide/ip_fragment_reassembly_lib.rst
index 5010472246..176186e3ea 100644
--- a/doc/guides/prog_guide/ip_fragment_reassembly_lib.rst
+++ b/doc/guides/prog_guide/ip_fragment_reassembly_lib.rst
@@ -43,8 +43,8 @@ Note that all update/lookup operations on Fragment Table are not thread safe.
 So if different execution contexts (threads/processes) will access the same table simultaneously,
 then some external syncing mechanism have to be provided.
 
-Each table entry can hold information about packets of up to ``RTE_LIBRTE_IP_FRAG_MAX_FRAGS`` fragments,
-where ``RTE_LIBRTE_IP_FRAG_MAX_FRAGS`` defaults to:
+Each table entry can hold information about packets of up to ``RTE_IP_FRAG_MAX_FRAGS`` fragments,
+where ``RTE_IP_FRAG_MAX_FRAGS`` defaults to:
 
 .. literalinclude:: ../../../config/rte_config.h
     :start-after: ip_fragmentation defines 8<
diff --git a/doc/guides/sample_app_ug/ip_reassembly.rst b/doc/guides/sample_app_ug/ip_reassembly.rst
index 5280bf4ea0..9cf4fb3f7d 100644
--- a/doc/guides/sample_app_ug/ip_reassembly.rst
+++ b/doc/guides/sample_app_ug/ip_reassembly.rst
@@ -135,7 +135,7 @@ Fragment table maintains information about already received fragments of the pac
 Each IP packet is uniquely identified by triple <Source IP address>, <Destination IP address>, <ID>.
 To avoid lock contention, each RX queue has its own Fragment Table,
 e.g. the application can't handle the situation when different fragments of the same packet arrive through different RX queues.
-Each table entry can hold information about packet consisting of up to RTE_LIBRTE_IP_FRAG_MAX_FRAGS fragments.
+Each table entry can hold information about packet consisting of up to RTE_IP_FRAG_MAX_FRAGS fragments.
 
 .. literalinclude:: ../../../examples/ip_reassembly/main.c
     :language: c
@@ -147,7 +147,7 @@ Mempools Initialization
 ~~~~~~~~~~~~~~~~~~~~~~~
 
 The reassembly application demands a lot of mbuf's to be allocated.
-At any given time up to (2 \* max_flow_num \* RTE_LIBRTE_IP_FRAG_MAX_FRAGS \* <maximum number of mbufs per packet>)
+At any given time up to (2 \* max_flow_num \* RTE_IP_FRAG_MAX_FRAGS \* <maximum number of mbufs per packet>)
 can be stored inside Fragment Table waiting for remaining fragments.
 To keep mempool size under reasonable limits and to avoid situation when one RX queue can starve other queues,
 each RX queue uses its own mempool.
diff --git a/examples/ip_fragmentation/main.c b/examples/ip_fragmentation/main.c
index 744a1aa9b4..1e4471891b 100644
--- a/examples/ip_fragmentation/main.c
+++ b/examples/ip_fragmentation/main.c
@@ -71,7 +71,7 @@
 /*
  * Max number of fragments per packet expected - defined by config file.
  */
-#define	MAX_PACKET_FRAG RTE_LIBRTE_IP_FRAG_MAX_FRAG
+#define	MAX_PACKET_FRAG RTE_IP_FRAG_MAX_FRAG
 
 #define NB_MBUF   8192
 
diff --git a/examples/ip_reassembly/main.c b/examples/ip_reassembly/main.c
index bd0b1d31de..16607d99f3 100644
--- a/examples/ip_reassembly/main.c
+++ b/examples/ip_reassembly/main.c
@@ -69,7 +69,7 @@
 #define	MIN_FLOW_TTL	1
 #define	DEF_FLOW_TTL	MS_PER_S
 
-#define MAX_FRAG_NUM RTE_LIBRTE_IP_FRAG_MAX_FRAG
+#define MAX_FRAG_NUM RTE_IP_FRAG_MAX_FRAG
 
 /* Should be power of two. */
 #define	IP_FRAG_TBL_BUCKET_ENTRIES	16
diff --git a/examples/ipsec-secgw/ipsec_worker.h b/examples/ipsec-secgw/ipsec_worker.h
index ac980b8bcf..918e6b5200 100644
--- a/examples/ipsec-secgw/ipsec_worker.h
+++ b/examples/ipsec-secgw/ipsec_worker.h
@@ -291,7 +291,7 @@ send_fragment_packet(struct lcore_conf *qconf, struct rte_mbuf *m,
 	len = tbl->len;
 
 	/* free space for new fragments */
-	if (len + RTE_LIBRTE_IP_FRAG_MAX_FRAG >=  RTE_DIM(tbl->m_table)) {
+	if (len + RTE_IP_FRAG_MAX_FRAG >=  RTE_DIM(tbl->m_table)) {
 		send_burst(qconf, len, port);
 		len = 0;
 	}
diff --git a/lib/ip_frag/ip_reassembly.h b/lib/ip_frag/ip_reassembly.h
index a9f97aefca..77c22ca9d1 100644
--- a/lib/ip_frag/ip_reassembly.h
+++ b/lib/ip_frag/ip_reassembly.h
@@ -16,7 +16,7 @@ enum {
 	IP_LAST_FRAG_IDX,    /* index of last fragment */
 	IP_FIRST_FRAG_IDX,   /* index of first fragment */
 	IP_MIN_FRAG_NUM,     /* minimum number of fragments */
-	IP_MAX_FRAG_NUM = RTE_LIBRTE_IP_FRAG_MAX_FRAG,
+	IP_MAX_FRAG_NUM = RTE_IP_FRAG_MAX_FRAG,
 	/* maximum number of fragments per packet */
 };
 
diff --git a/lib/ip_frag/rte_ip_frag.h b/lib/ip_frag/rte_ip_frag.h
index 2ad318096b..6465ec316b 100644
--- a/lib/ip_frag/rte_ip_frag.h
+++ b/lib/ip_frag/rte_ip_frag.h
@@ -32,7 +32,7 @@ struct rte_mbuf;
 
 /** death row size in mbufs */
 #define RTE_IP_FRAG_DEATH_ROW_MBUF_LEN \
-	(RTE_IP_FRAG_DEATH_ROW_LEN * (RTE_LIBRTE_IP_FRAG_MAX_FRAG + 1))
+	(RTE_IP_FRAG_DEATH_ROW_LEN * (RTE_IP_FRAG_MAX_FRAG + 1))
 
 /** mbuf death row (packets to be freed) */
 struct rte_ip_frag_death_row {